#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_manager4xi.py">
#<abstract4xi abstract = "tests manager4xi"/>
#<verify4xi verification = "10" target = "manager4xi.py"/>
#<contextualize4xi context = "process4xi.py; queue4xi.py; pipe4xi.py; lock4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'test_manager4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import _winapi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from process4xi import Process4Xi
from queue4xi  import Queue4Xi
from pipe4xi import Pipe4Xi
from lock4xi import Lock4Xi
from manager4xi import Manager4Xi
from public_methods4xi import public_methods4xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>
# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set_trace4xi" usage = "
#   setting trace using pickle4xi sub functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def set_trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    t2xi = Print4Xi()

    
    print('=' *33)
    print("STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)")
    print('=' *33)
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
        
    keys2pickledb = sorted(PickleKB4Xi.keys())
    
    for key2pickledb in keys2pickledb:
     
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
        # STARTING LETTER :  _    

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        
        # print('~' *33)        
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # STARTING DICTIONARY:  {'xml_trace_sense4xi': 'NACK4XI', '_reduce_partial4xi': 'NACK4XI', 'set_listener4xi': 'NACK4XI', 'sense_lock4xi': 'NACK4XI', '_run_after_forkers4xi ': 'NACK4XI', 'ace_cache4xi': 'NACK4XI', 'xml_trace_reason4xi': 'NACK4XI', 'reason_cache4xi': 'NACK4XI', '_rebuild_partial4xi': 'NACK4XI', 'init_listener4xi': 'NACK4XI', '_MainProcess4Xi': 'NACK4XI', 'close_cache4xi': 'NACK4XI', '_xml_loads4xi': 'NACK4XI', 'ace_listener4xi': 'NACK4XI', '_xml_dumps4xi': 'NACK4XI', '_cleanup4xi': 'NACK4XI', '_serve4xi': 'NACK4XI', 'reason_listener4xi': 'NACK4XI', '_run_after_forkers4xi': 'NACK4XI', '_exit_function4xi': 'NACK4XI', 'clear_cache4xi': 'NACK4XI', '_finalizer4xi': 'NACK4XI', 'ace_lock4xi': 'NACK4XI', 'acquire_lock4xi': 'NACK4XI', '_get_listener4xi': 'NACK4XI', 'sense_listener4xi': 'NACK4XI', 'release_lock4xi': 'NACK4XI', 'get_cache4xi': 'NACK4XI', 'init_cache4xi': 'NACK4XI', 'reason_lock4xi': 'NACK4XI', '_reduce_method_descriptor4xi': 'NACK4XI', 'reset_cache4xi': 'NACK4XI', '_reset4xi': 'NACK4XI', 'add_cache4xi': 'NACK4XI', 'reset_listener4xi': 'NACK4XI', '_run_finalizers4xi': 'NACK4XI', 'remove_cache4xi': 'NACK4XI', '_new_value4xi': 'NACK4XI', 'sense_cache4xi': 'NACK4XI', 'get_listener4xi': 'NACK4XI', '_bootstrap4xi': 'NACK4XI', 'xml_trace_ace4xi': 'NACK4XI', 'get_lock4xi': 'NACK4XI', '_C4Xi': 'NACK4XI', '_check_logger_class4xi': 'NACK4XI', 'init_lock4xi': 'NACK4XI', '_reduce_method4xi': 'NACK4XI', 'reset_lock4xi': 'NACK4XI'}

                    
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # _C4Xi, _MainProcess4Xi, _bootstrap4xi ....  
            
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
            
            

            # ---------------------------------------------------------------------------------    
            # skip pickling
            # ---------------------------------------------------------------------------------     
        
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("MARKED TO BE TRACED object: ", object2pickle)
            
                dictionary2pickle[key2dictionary] = 'TRACE4XI' 
                # print('~' *33)
            else:
                pass  
                   
                                         
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("*** ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
            

        
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
            
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # COMPLETED  DICTIONARY:
        #  {'xml_trace_sense4xi': 'ACK4XI', '_reduce_partial4xi': 'ACK4XI', 'set_listener4xi': 'ACK4XI', 'sense_lock4xi': 'ACK4XI', '_run_after_forkers4xi ': 'ACK4XI', 'ace_cache4xi': 'ACK4XI', 'xml_trace_reason4xi': 'ACK4XI', 'reason_cache4xi': 'ACK4XI', '_rebuild_partial4xi': 'ACK4XI', 'init_listener4xi': 'ACK4XI', '_MainProcess4Xi': 'ACK4XI', 'close_cache4xi': 'ACK4XI', '_xml_loads4xi': 'ACK4XI', 'ace_listener4xi': 'ACK4XI', '_xml_dumps4xi': 'ACK4XI', '_cleanup4xi': 'ACK4XI', '_serve4xi': 'ACK4XI', 'reason_listener4xi': 'ACK4XI', '_run_after_forkers4xi': 'ACK4XI', '_exit_function4xi': 'ACK4XI', 'clear_cache4xi': 'ACK4XI', '_finalizer4xi': 'ACK4XI', 'ace_lock4xi': 'ACK4XI', 'acquire_lock4xi': 'ACK4XI', '_get_listener4xi': 'ACK4XI', 'sense_listener4xi': 'ACK4XI', 'release_lock4xi': 'ACK4XI', 'get_cache4xi': 'ACK4XI', 'init_cache4xi': 'ACK4XI', 'reason_lock4xi': 'ACK4XI', '_reduce_method_descriptor4xi': 'ACK4XI', 'reset_cache4xi': 'ACK4XI', '_reset4xi': 'ACK4XI', 'add_cache4xi': 'ACK4XI', 'reset_listener4xi': 'ACK4XI', '_run_finalizers4xi': 'ACK4XI', 'remove_cache4xi': 'ACK4XI', '_new_value4xi': 'ACK4XI', 'sense_cache4xi': 'ACK4XI', 'get_listener4xi': 'ACK4XI', '_bootstrap4xi': 'ACK4XI', 'xml_trace_ace4xi': 'ACK4XI', 'get_lock4xi': 'ACK4XI', '_C4Xi': 'ACK4XI', '_check_logger_class4xi': 'ACK4XI', 'init_lock4xi': 'ACK4XI', '_reduce_method4xi': 'ACK4XI', 'reset_lock4xi': 'ACK4XI'}

        
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
                    
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # COMPLETED LETTER :  _, a ... z            
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------  
           
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
 
    print('=' *33)
    print("COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)")
    print('=' *33)
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(p2xi):
  

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-manager4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Manager4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Manager4Xi in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(p2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-manager4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Manager4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Manager4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(p2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-manager4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Manager4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Manager4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(p2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "sense" usage = "
#   sensing multiprocessing4xi
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def sense(target_param, queue_param, pipe_param,lock_param,dict_param,list_param):
    target_xi2 = target_param                    # target to be sensed
    queue_xi2 = queue_param                      # queue
    pipe_publisher_channel_xi2 = pipe_param      # pipe
    lock_xi2 = lock_param                        # lock for resources
    dict_xi2 = dict_param                        # dictionary created by the manager
    list_xi2 = list_param                        # list created by the manager
    
    
    print("SENSE: ", target_xi2)
    
    # ---------------------------------------------------------------------------------------------
    # put a message to the queue
    # 
    queue_xi2.put(['DragonXi2_00', target_xi2, 'sensing!']) # puts to its queue
    # ---------------------------------------------------------------------------------------------
    # reserve the pipe using the lock, send messages and release the pipe
    # 
    lock_xi2.acquire()

    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_01', 'BIO ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_02', 'CO2 ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_03', 'Coal ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_04', 'Diesel ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_05', 'Electricity ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_06', 'Fusion ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_07', 'Gas ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_08', 'Geo ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_09', 'Hydrogen ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_10', 'Lithium ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_11', 'Nuclear Power ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_12', 'Ocean ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_13', 'Oil ',target_xi2]) 
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_14', 'Solar ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_15', 'Wind ',target_xi2])
    
    dict_xi2[1] = "BIO"
    dict_xi2[2] = "CO2"
    dict_xi2[3] = "Coal"
    dict_xi2[4] = "Diesel"
    dict_xi2[5] = "Electricity"
    dict_xi2[6] = "Fusion"
    dict_xi2[7] = "Gas"
    dict_xi2[8] = "Geo"
    dict_xi2[9] = "Hydrogen"
    dict_xi2[10] = "Lithium"
    dict_xi2[11] = "Nuclear Power"
    dict_xi2[12] = "Ocean"
    dict_xi2[13] = "Oil"
    dict_xi2[14] = "Solar"
    dict_xi2[15] = "Wind"
    

    lock_xi2.release() 
#</function4xi>  
          
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reason" usage = "
#   reasoning multiprocessing4xi
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def reason(target_param, queue_param, pipe_param,lock_param,dict_param,list_param):
    target_xi4 = target_param
    queue_xi4 = queue_param
    pipe_publisher_channel_xi4 = pipe_param
    lock_xi4 = lock_param
    dict_xi4 = dict_param
    list_xi8 = list_param
    
    print("REASON: ", target_xi4)
    # ---------------------------------------------------------------------------------------------
    # put a message to the queue
    # 
    queue_xi4.put(['DragonXi4_00', target_xi4, 'portfolio must be sustainable!']) # puts to its queue 
    # ---------------------------------------------------------------------------------------------
    # reserve the pipe using the lock, send messages and release the pipe
    # 
    lock_xi4.acquire()
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_01', 'BIO ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_02', 'Geo ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_03', 'Hydrogen ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_04', 'Nuclear Power ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_05', 'Ocean ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_06', 'Solar ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_07', 'Wind ',target_xi4])    

    dict_xi4[1] = "BIO"
    dict_xi4[2] = "Geo"
    dict_xi4[3] = "Hydrogen"
    dict_xi4[4] = "Nuclear Power"
    dict_xi4[5] = "Ocean"
    dict_xi4[6] = "Solar"
    dict_xi4[7] = "Wind"
    
    lock_xi4.release()
#</function4xi>  

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "ace" usage = "
#   ace multiprocessing4xi
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def ace(target_param, queue_param, pipe_param,lock_param,dict_param,list_param):
    # ---------------------------------------------------------------------------------------------
    # 
    # 
    target_xi8 = target_param
    queue_xi8 = queue_param
    pipe_publisher_channel_xi8 = pipe_param
    lock_xi8 = lock_param
    dict_xi8 = dict_param
    list_xi8 = list_param
    
    print("ACE: ", target_xi8)
    # ---------------------------------------------------------------------------------------------
    # put a message to the queue
    # 
    queue_xi8.put(['DragonXi8_00', target_xi8, 'to be aced!']) # puts to its queue       
    
    # ---------------------------------------------------------------------------------------------
    # reserve the pipe using the lock, send messages and release the pipe
    # 
    lock_xi8.acquire()
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_01', 'BIO ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_02', 'Hydrogen ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_03', 'Nuclear Power ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_04', 'Solar ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_05', 'Wind ',target_xi8])    

    dict_xi8[1] = "BIO"
    dict_xi8[2] = "Hydrogen"
    dict_xi8[3] = "Nuclear Power"
    dict_xi8[4] = "Solar"
    dict_xi8[5] = "Wind"
    
    lock_xi8.release()

#</function4xi>  
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-manager4xi" usage = " 
#   testing manager4xi in multiprocessing
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def test_manager4xi():
    global t2xi 
    global trace_object_count
    
    
    # ---------------------------------------------------------------------------------------------    
    # set Trace
    # ---------------------------------------------------------------------------------------------    
    set_trace4xi()


    try:


        # ---------------------------------------------------------------------------------------------
        # create multiprocessing queues for sensing, reasoning and acing
        # ---------------------------------------------------------------------------------------------
        
        print('=' *33)        
        print("\n STEP: CREATING THREE QUEUE4XI OBJECTS FOR SENSING, REASONING AND ACING")
        print('=' *33)
        
        queue2xi = Queue4Xi()
        queue4xi = Queue4Xi()
        queue8xi = Queue4Xi()
        
        print('=' *33)        
        print("\n STEP: CREATED THREE QUEUE4XI OBJECTS FOR SENSING, REASONING AND ACING")
        print('=' *33)
            
        # ---------------------------------------------------------------------------------------------
        # create multiprocessing pipes with consumer and publisher ends
        # ---------------------------------------------------------------------------------------------         
        print('=' *33)    
        print("\n STEP: CREATING THREE PIPES WITH CONSUMER AND PUBLISHER ENDS")
        print('=' *33)    
        
        pipe2xi_consumer_channel, pipe2xi_publisher_channel = Pipe4Xi()
        pipe4xi_consumer_channel, pipe4xi_publisher_channel = Pipe4Xi()
        pipe8xi_consumer_channel, pipe8xi_publisher_channel = Pipe4Xi()
        
        print('=' *33)    
        print("\n STEP: CREATED THREE PIPES WITH CONSUMER AND PUBLISHER ENDS")
        print('=' *33)    
           
        # ---------------------------------------------------------------------------------------------
        # create three locks
        # ---------------------------------------------------------------------------------------------   
        
        print('=' *33)    
        print("\n STEP: CREATING THREE LOCKS")
        print('=' *33)    
          
        lock_xi2 = Lock4Xi()
        lock_xi4 = Lock4Xi()
        lock_xi8 = Lock4Xi()    
        
        print('=' *33)    
        print("\n STEP: CREATED THREE LOCKS")
        print('=' *33)    
          
        # ---------------------------------------------------------------------------------------------
        # create three managers
        # --------------------------------------------------------------------------------------------- 
        
        print('=' *33)    
        print("\n STEP: CREATING THREE MANAGERS")
        print('=' *33)    
            

        manager2xi = Manager4Xi()
        manager4xi = Manager4Xi()
        manager8xi = Manager4Xi()
        
        print('=' *33)    
        print("\n STEP: CREATED THREE MANAGERS")
        print('=' *33)    
            
        # ---------------------------------------------------------------------------------------------
        # create three dictionaries using each manager
        # ---------------------------------------------------------------------------------------------      
        print('=' *33)         
        print("\n STEP: CREATING THREE DICTIONARIES USING EACH MANAGER")
        print('=' *33)         
        
        dict2xi = manager2xi.dict()
        dict4xi = manager4xi.dict()
        dict8xi = manager8xi.dict()
        
        print('=' *33)         
        print("\n STEP: CREATED THREE DICTIONARIES USING EACH MANAGER")
        print('=' *33)              
        
        # ---------------------------------------------------------------------------------------------
        # create three lists using each manager
        # ---------------------------------------------------------------------------------------------          
        print('=' *33)         
        print("\n STEP: CREATING THREE LISTS USING EACH MANAGER")
        print('=' *33)         
           
        list2xi = manager2xi.list(range(15))
        list4xi = manager4xi.list(range(7))
        list8xi = manager8xi.list(range(5))
        
        print('=' *33)         
        print("\n STEP: CREATED THREE LISTS USING EACH MANAGER")
        print('=' *33)         
         
    
        # ---------------------------------------------------------------------------------------------
        # SENSE IT!
        # ---------------------------------------------------------------------------------------------
        print('=' *33)
        print("\n STEP: SENSE IT!")
        print("\n at this phase manager2xi managers dict2xi and list2xi objects")
        print("\n now create the object process2xi with function sense, which")
        print("\n puts data to process2xi's queue and sends data to process pipe using dict2xi and list2xi,")
        print("\n which are managed by manager2xi object ")   
        print('=' *33)
        
        
        print('=' *33)         
        print("\n STEP: CREATING PROCESS FOR SENSING")
        print('=' *33)         
           
        process2xi = Process4Xi(target=sense, args=('Energy ',queue2xi, pipe2xi_publisher_channel,lock_xi2,dict2xi,list2xi))

        
        print('=' *33)         
        print("\n STEP: CREATED PROCESS FOR SENSING")
        print('=' *33)         
         
        # ---------------------------------------------------------------------------------------------
        # start process object process2xi
        # ---------------------------------------------------------------------------------------------
        process2xi.start()
        
        print('=' *33)         
        print("\n STEP: STARTED PROCESS FOR SENSING")
        print('=' *33)         
        
        # ---------------------------------------------------------------------------------------------
        # run process object process2xi
        # ---------------------------------------------------------------------------------------------
        process2xi.run()
        
        print('=' *33)         
        print("\n STEP: RUN PROCESS FOR SENSING")
        print('=' *33)         
                 
        # ---------------------------------------------------------------------------------------------
        # get from queue2xi
        # ---------------------------------------------------------------------------------------------
        print('=' *33)         
        print("\n STEP: GETTING FROM QUEUE FOR SENSING: ")
        print('=' *33)         
              
        print (queue2xi.get())
        
        # ---------------------------------------------------------------------------------------------
        # receive from pipe2xi's consumer channel
        # ---------------------------------------------------------------------------------------------
        print('=' *33)         
        print("\n STEP: RECEIVING FROM PIPE CONSUMER CHANNEL: ")
        print('=' *33)         
                      
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        print (pipe2xi_consumer_channel.recv())
        
        # ---------------------------------------------------------------------------------------------
        # print dictionary created by manager2xi and updated by process2xi
        # ---------------------------------------------------------------------------------------------
        print('=' *33)  
        print("\n STEP: DICTIONARY CREATED BY MANAGER2XI AND UPDATED BY PROCESS2XI:")
        print (dict2xi)
        
        # ---------------------------------------------------------------------------------------------
        # print list created by manager2xi and updated by process2xi
        # ---------------------------------------------------------------------------------------------
        print('=' *33)         
        print("\n STEP: LIST FOR MANAGER2XI AND PROCESS2XI:")
        print (list2xi)
        
        # ---------------------------------------------------------------------------------------------
        # join the process
        # ---------------------------------------------------------------------------------------------
        print('=' *33)         
        print("\n STEP: JOINING PROCESS2XI - WAITING UNTIL CHILD PROCESSES TERMINATE")
        print (list2xi)        
        process2xi.join()
        
        # ---------------------------------------------------------------------------------------------
        # REASON IT!
        #        create a process and use its services such the content it sends via its queue and pipe    
        # --------------------------------------------------------------------------------------------- 
        print('=' *33)      
        print("\n STEP: REASON IT!")
        print('=' *33)      
        
        process4xi = Process4Xi(target=reason, args=('Energy ',queue4xi, pipe4xi_publisher_channel,lock_xi4,dict4xi,list4xi))
        
        print('=' *33)      
        print("\n STEP: CREATED PROCESS FOR REASONING!")
        print('=' *33)           
        
        process4xi.start()
        
        
        print('=' *33)      
        print("\n STEP: STARTED PROCESS FOR REASONING!")
        print('=' *33) 
        
        
        print('=' *33)      
        print("\n STEP: RUNNING PROCESS FOR REASONING!")
        print('=' *33)           
        
        process4xi.run()
        
        
        print('=' *33)      
        print("\n STEP: RUN PROCESS FOR REASONING!")
        print('=' *33)                      
        
        print('=' *33)      
        print("\n STEP: RECEIVING FROM REASONING QUEUE:")
        print('=' *33)              
        print (queue4xi.get())
        
        
        print('=' *33)      
        print("\n STEP: RECEIVING FROM PIPE:")
        print('=' *33)            
        print (pipe4xi_consumer_channel.recv())
        print (pipe4xi_consumer_channel.recv())
        print (pipe4xi_consumer_channel.recv())
        print (pipe4xi_consumer_channel.recv())
        print (pipe4xi_consumer_channel.recv())
        print (pipe4xi_consumer_channel.recv())
        print (pipe4xi_consumer_channel.recv())
        
        print('=' *33)          
        print("\n STEP: DICTIONARY CREATED BY MANAGER4XI AND UPDATED BY PROCESS4XI:")
        print (dict4xi)
        
        print('=' *33)            
        print("\n STEP: LIST FOR MANAGER4XI AND PROCESS4XI:")
        print (list4xi)
        print('=' *33)      
        
        print('=' *33)            
        print("\n STEP: JOINING REASONING PROCESS")
        print('=' *33)

                            
        process4xi.join()
        
        print('=' *33)            
        print("\n STEP: JOINED REASONING PROCESS")
        print('=' *33)
        
        # ---------------------------------------------------------------------------------------------
        # ACE IT!
        #        create a process and use its services such the content it sends via its queue and pipe    
        # --------------------------------------------------------------------------------------------- 
        print('=' *33)     
        print("\n STEP: ACE IT!")
        print('=' *33)     
        
        print('=' *33)            
        print("\n STEP: CREATING ACE PROCESS")
        print('=' *33)        
        
        process8xi = Process4Xi(target=ace, args=('Energy ',queue8xi, pipe8xi_publisher_channel,lock_xi8,dict8xi,list8xi))
        
        print('=' *33)            
        print("\n STEP: CREATED ACE PROCESS")
        print('=' *33)        
        
        print('=' *33)            
        print("\n STEP: STARTING ACE PROCESS")
        print('=' *33)        
               
        process8xi.start()
        
        print('=' *33)            
        print("\n STEP: STARTED ACE PROCESS")
        print('=' *33)        
           
        print('=' *33)            
        print("\n STEP: RUNNING ACE PROCESS")
        print('=' *33)        
               
        process8xi.run()
        
        print('=' *33)            
        print("\n STEP: RUN ACE PROCESS")
        print('=' *33)        
           
        print('=' *33)            
        print("\n STEP: GETTING FROM ACE QUEUE")
        print('=' *33)        
                       
        print (queue8xi.get())
        
           
        print('=' *33)            
        print("\n STEP: GOT FROM ACE QUEUE")
        print('=' *33)        
        
        print('=' *33)            
        print("\n STEP: RECEIVING FROM ACE PIPE")
        print('=' *33)        
             
        print (pipe8xi_consumer_channel.recv())
        print (pipe8xi_consumer_channel.recv())
        print (pipe8xi_consumer_channel.recv())
        print (pipe8xi_consumer_channel.recv())
        print (pipe8xi_consumer_channel.recv())
        
        print('=' *33)            
        print("\n STEP: RECEIVED FROM ACE PIPE")
        print('=' *33)        
          
        print('=' *33)         
        print("\n STEP: DICTIONARY CREATED BY MANAGER8XI AND UPDATED BY PROCESS8XI:")
        print (dict8xi)
        
        print('=' *33)           
        print("\n STEP: LIST FOR MANAGER8XI AND PROCESS8XI:")
        print (list8xi)
        
        print('=' *33)           
        print("\n STEP: JOINING ACE PROCESS8XI:")
        print (list8xi)
           
        process8xi.join()
        
        
        print('=' *33)           
        print("\n STEP: JOINED ACE PROCESS8XI:")
        print (list8xi)
             
        # ---------------------------------------------------------------------------------------------
        # Notes:
        #       above assumed the main to know amount of messages
        #       no locks were used
        # ---------------------------------------------------------------------------------------------
        print("\n STEP: Theory of Server processes and Manager objects")
        print("\n")
        print("\n Description: A manager object returned by Manager4Xi")
        print("\n 1) controls a server process, which") 
        print("\n~ holds Python objects and ")
        print("\n~ allows other processes to manipulate them using proxies.")
        print("\n 2) supports types such as list, dict, Namespace, Lock, RLock,") 
        print("\n~ Semaphore, BoundedSemaphore, Condition,") 
        print("\n~ Event, Queue, Value and Array")
        print("\n")
        print("\n 3) acquires a lock,") 
        print("\n    before processing and releases that lock after completing")
        print("\n===============================================================") 
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
           
    
#</function4xi>         
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   testing manager4xi
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def main():

    print('=' *33)
    print("SENSING MANAGER4XI WITH YOURDRAGONXI!")  
    print('=' *33)
        
    test_manager4xi()  
    
    print('=' *33)
    print("SENSED MANAGER4XI WITH YOURDRAGONXI!")    
    print('=' *33) 
                        
#</function4xi>
          

# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   testing manager4xi
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">     
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</function4xi>   

    
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_manager4xi.txt
#   sense-test-manager4xi.xml
#   reason-test-manager4xi.xml
#   ace-test-manager4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_manager4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

